;
; This macro file makes it easier to put text on the screen.
; It only works for archives with one file - D3.W is not set.
; Textarchives should only be one file. If you want multifile
; support, make your own macro, or set D3.W before using the macro.
;
; If you store the macroparameters in dataregisters, be careful to
; choose the correct registers. For example, if you store the
; Y coordinate in the D0 register, the Y coordinate will be the same
; as the X coordinate since D0 is overwritten.
;

H_WriteStr MACRO         ; int X, int Y, int NO, char* STR
 move.w \1,d0
 move.w \2,d1            ; Writes a huffman compressed string
 move.w \3,d4
 lea    \4,a0
 jsr hufflib[write_string]
 ENDM

H_WriteStrI MACRO  ; int X, int Y, int NO, char* STR
 move.w \1,d0
 move.w \2,d1            ; Writes a huffman compressed string, inverted colors
 move.w \3,d4
 lea    \4,a0
 jsr hufflib[write_string_inv]
 ENDM

;
; Same as above, except that the used registers (D0,D1,D4,A0) are pushed
; to the stack so they won't change after the macro
;

H_WriteStrS MACRO  ; int X, int Y, int NO, char* STR
 movem.l d0-d1/d4/a0,-(a7)
 move.w \1,d0
 move.w \2,d1            ; Writes a huffman compressed string
 move.w \3,d4
 lea    \4,a0
 jsr hufflib[write_string]
 movem.l (a7)+,d0-d1/d4/a0
 ENDM

H_WriteStrIS MACRO ; int X, int Y, int NO, char* STR
 movem.l d0-d1/d4/a0,-(a7)
 move.w \1,d0
 move.w \2,d1            ; Writes a huffman compressed string, inverted colors
 move.w \3,d4
 lea    \4,a0
 jsr hufflib[write_string_inv]
 movem.l (a7)+,d0-d1/d4/a0
 ENDM

;
; A standard macro to change font. Requires romlib
;

SetFont MACRO
 move.w \1,-(a7)
 jsr romlib[set_font]
 addq   #2,a7
 ENDM
